# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# useful macros/fcts

MACRO(MACRO_AddTest srcDir)
    FILE(GLOB tfiles RELATIVE ${srcDir} ${srcDir}/*)
    FOREACH(tfile ${tfiles})
        SET(spath ${srcDir}/${tfile})
        IF(NOT IS_DIRECTORY ${spath} AND 
           ${spath} MATCHES ".+\\.py$" AND 
           NOT ${tfile} STREQUAL "__init__.py")
            STRING(REPLACE "${PROJECT_SOURCE_DIR}/" "" strip ${spath}) 
            MESSAGE(STATUS "Adding test ${strip}")
            ADD_TEST(NAME ${strip} 
                     WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} 
                     COMMAND ${PYTHON_EXECUTABLE} run_fpm.py --nogui --clean ${strip})            
        ELSE()
            MACRO_AddTest(${srcDir}/${tfile})
        ENDIF()
    ENDFOREACH()
ENDMACRO()


MACRO(MACRO_DebugPostfix libname)
    IF(MSVC)
        SET_TARGET_PROPERTIES(${libname} PROPERTIES DEBUG_POSTFIX "_d")
    ENDIF(MSVC)
ENDMACRO()

